SystemOrganization addCategory: #'acceptit-Tests-Fixtures'!
SystemOrganization addCategory: #'acceptit-Tests'!
SystemOrganization addCategory: #'acceptit-Core-Model'!
SystemOrganization addCategory: #'acceptit-Compiler'!
(PackageInfo named: 'acceptit') postscript: '"below, add code to be run after the loading of this package"
ACUserStory named: #AName
	purpose: ''impress the ladies''
	role: ''Casanova''
	means: ''Prosecco'''!

Compiler subclass: #ACCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:18'!
compile: origCode in: cls classified: aCategory notifying: notify ifFail: failBlock

	^ self compile: origCode in: cls notifying: notify ifFail: failBlock! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 12:35'!
compile: origCode in: cls notifying: notify ifFail: failBlock

	| origCodeStream translatedCode |
	origCodeStream := origCode asString readStream.
	self from: origCodeStream class: cls context: nil notifying: notify.
	[ | parseTree |		
		parseTree := self parserClass matchStream: origCodeStream with: #scenario withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #translate.
	] on: OM2Fail do: [:ignore |
		self notify: '<-- parse error around here -->' at: origCodeStream position.
		^ failBlock value
	].
	^ self class superclass new
		compile: translatedCode readStream
		in: cls
		notifying: notify
		ifFail: failBlock! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:24'!
parse: aStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock

	^ [
		| parseTree translatedCode code |
		parseTree := self parserClass matchStream: aStream with: #userStory withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #translate.
		Parser new parse: translatedCode readStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock
	] on: OM2Fail do: [aBlock value]! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:31'!
parserClass

	^ ACParser! !

Object subclass: #ACTestResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Fixtures'!

!ACTestResource class methodsFor: 'strings-given' stamp: 'topa 5/27/2010 14:59'!
given

	^ 'Given I have a web site'! !

!ACTestResource class methodsFor: 'strings-means' stamp: 'topa 5/20/2010 09:36'!
means

	^ 'I want to do something.'! !

!ACTestResource class methodsFor: 'strings-means' stamp: 'topa 5/20/2010 09:36'!
meansOptionalTo

	^ 'I want a cake.'! !

!ACTestResource class methodsFor: 'strings-means' stamp: 'topa 5/20/2010 09:37'!
meansOptionalToWithAn

	^ 'I want an embedded sleeping hour.'! !

!ACTestResource class methodsFor: 'strings-purpose' stamp: 'topa 5/20/2010 09:36'!
purpose

	^ 'In order to achieve something.'! !

!ACTestResource class methodsFor: 'strings-role' stamp: 'topa 5/20/2010 09:43'!
role

	^ 'As a role'! !

!ACTestResource class methodsFor: 'strings-role' stamp: 'topa 5/20/2010 09:43'!
roleWithAn

	^ 'As an emancipated role'! !

!ACTestResource class methodsFor: 'strings-role' stamp: 'topa 5/20/2010 09:44'!
roleWithPlural

	^ 'As roles'! !

!ACTestResource class methodsFor: 'strings-Scenario-valid' stamp: 'topa 5/27/2010 14:51'!
scenario

	^
'Given I have a web site
When I go to the web site
Then I see "Hello World"'! !

!ACTestResource class methodsFor: 'strings-Scenario-valid' stamp: 'topa 6/3/2010 11:01'!
scenarioDecompiled

	^
'scenario1
	self given: ''I have a web site''.
	self when: ''I go to the web site''.
	self then: ''I see "Hello World"''.'! !

!ACTestResource class methodsFor: 'strings-Scenario-invalid' stamp: 'topa 5/27/2010 15:03'!
scenarioInvalidNewlines

	^
'Given I have a web site

When I go to the web site

Then I see "Hello World"'! !

!ACTestResource class methodsFor: 'strings-Scenario-invalid' stamp: 'topa 5/27/2010 15:04'!
scenarioInvalidOrder

	^
'When I go to the web site
Given I have a web site
Then I see "Hello World"'! !

!ACTestResource class methodsFor: 'strings-Scenario-invalid' stamp: 'topa 5/27/2010 15:04'!
scenarioInvalidSyntax

	^
'Gvien I have a web site
Wehn I go to the web site
Tehn I see "Hello World"'! !

!ACTestResource class methodsFor: 'strings-Scenario-invalid' stamp: 'topa 5/27/2010 15:05'!
scenarioInvalidTrailers

	^
'Given I have a web site
When I go to the web site
Then I see "Hello World"
Yes, This would be awesome.'! !

!ACTestResource class methodsFor: 'strings-then' stamp: 'topa 5/27/2010 14:58'!
then

	^ 'Then I see "Hello World"'! !

!ACTestResource class methodsFor: 'strings-UserStory-valid' stamp: 'topa 5/20/2010 10:07'!
userStory

	^
'A Title
In order to achieve something
As a role
I want to do something.'! !

!ACTestResource class methodsFor: 'strings-UserStory-valid' stamp: 'topa 6/3/2010 13:36'!
userStoryDecompiled

	^
'ACUserStory named: #ATitle
	purpose: ''achieve something''
	role: ''role''
	means: ''do something.''
'! !

!ACTestResource class methodsFor: 'strings-UserStory-invalid' stamp: 'topa 5/20/2010 09:27'!
userStoryInvalidNewlines

	^
'A Title
In order to achieve something

As a role

I want to do something.'! !

!ACTestResource class methodsFor: 'strings-UserStory-invalid' stamp: 'topa 5/20/2010 09:27'!
userStoryInvalidOrder

	^
'A Title
As a role
I want to do something
In order to achieve something.'! !

!ACTestResource class methodsFor: 'strings-UserStory-invalid' stamp: 'topa 5/20/2010 09:28'!
userStoryInvalidSyntax

	^
'A Title
In roder to achieve something
Asa role
I wnat ot do something.'! !

!ACTestResource class methodsFor: 'strings-UserStory-invalid' stamp: 'topa 5/20/2010 09:48'!
userStoryInvalidTrailers

	^
'A Title
In order to achieve something
As a role
I want to do something.

This is cool
'! !

!ACTestResource class methodsFor: 'strings-UserStory-invalid' stamp: 'topa 5/20/2010 09:28'!
userStoryMissingArgs

	^
'A Title
In order to
As a
I want'! !

!ACTestResource class methodsFor: 'strings-UserStory-valid' stamp: 'topa 5/20/2010 09:28'!
userStoryNewlineAfterTitle

	^
'A Title

In order to achieve something
As a role
I want to do something.'! !

!ACTestResource class methodsFor: 'strings-UserStory-valid' stamp: 'topa 5/20/2010 09:29'!
userStorySpacing

	^
'A Title
    In order to achieve something
	As a role
 	 I want to do something.'! !

!ACTestResource class methodsFor: 'strings-when' stamp: 'topa 5/27/2010 14:59'!
when

	^ 'When I go to the web site'! !

TestCase subclass: #ACCompilerScenarioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACCompilerScenarioTest methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 10:59'!
testScenarioCompilation

	| acMethod stMethod |

	acMethod := ACCompiler new compile: ACTestResource scenario  in: self class classified: nil notifying: nil ifFail: [].
	stMethod := Compiler new compile: ACTestResource scenarioDecompiled in: self class classified: nil notifying: nil ifFail: [].

	self 
		should: [acMethod selector = stMethod selector];
		should: [acMethod decompileString = stMethod decompileString].! !

TestCase subclass: #ACCompilerUserStoryTest
	instanceVariableNames: 'klassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 6/3/2010 14:07'!
directClassWithVariablesSet

	| theKlass |
	theKlass := (ACUserStory subclass: self klassName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: ACUserStory category).
	^ theKlass purpose: 'impress the ladies'; role: 'Casanova'; means: 'Prosecco'.! !

!ACCompilerUserStoryTest methodsFor: 'accessing' stamp: 'topa 6/3/2010 13:55'!
klassName

	^ klassName! !

!ACCompilerUserStoryTest methodsFor: 'accessing' stamp: 'topa 6/3/2010 13:55'!
klassName: anObject

	klassName := anObject! !

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 6/3/2010 14:01'!
parseTree

	^ ACTranslator match: (ACParser matchStream: 
'A Name For Testing
In order to impress the ladies
As a Casanova
I want Prosecco
' readStream with: #userStory withArgs: #() withPlaybackDebugging: false) with: #translate! !

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 6/3/2010 14:08'!
removeTestClass

	self klassName ifNotNilDo: [:name | 
		(Smalltalk globals at: name ifAbsent: [^ self]) removeFromSystemUnlogged].! !

!ACCompilerUserStoryTest methodsFor: 'running' stamp: 'topa 6/3/2010 13:57'!
setUp

	self klassName: #ANameForTesting.! !

!ACCompilerUserStoryTest methodsFor: 'running' stamp: 'topa 6/3/2010 14:02'!
tearDown

	self removeTestClass.! !

!ACCompilerUserStoryTest methodsFor: 'testing' stamp: 'topa 6/3/2010 14:05'!
testUserStoryCompilation

	| direct indirect generated |
	direct := self directClassWithVariablesSet definition.
	self removeTestClass.
	indirect := (ACUserStory named: self klassName
		purpose: 'impress the ladies' 
		role: 'Casanova'
		means: 'Prosecco') definition.
	self removeTestClass.
	generated := (Compiler evaluate: self parseTree notifying: nil logged: false) definition.
	self removeTestClass.
	
	self 
		should: [direct = indirect];
		should: [indirect = generated].! !

TestCase subclass: #ACParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

ACParserTest subclass: #ACParserScenarioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'db 6/7/2010 15:05'!
testScenarioGiven

		self should: [self match: ACTestResource given with: #givenLine].	! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'topa 5/27/2010 15:05'!
testScenarioInvalidNewlinesMatch

	self shouldnt: [self match: ACTestResource scenarioInvalidNewlines with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'topa 5/27/2010 15:06'!
testScenarioInvalidOrderMatch

	self shouldnt: [self match: ACTestResource scenarioInvalidOrder with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'topa 5/27/2010 15:06'!
testScenarioInvalidSyntaxMatch

	self shouldnt: [self match: ACTestResource scenarioInvalidSyntax with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'topa 5/27/2010 15:06'!
testScenarioInvalidTrailersMatch

	self shouldnt: [self match: ACTestResource scenarioInvalidTrailers with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'topa 5/27/2010 14:49'!
testScenarioMatch

	self should: [self match: ACTestResource scenario with: #scenario].
! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 5/27/2010 15:01'!
testScenarioThen

	self should: [self match: ACTestResource then with: #thenLine].	! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 5/27/2010 15:01'!
testScenarioWhen

	self should: [self match: ACTestResource when with: #whenLine].	! !

!ACParserTest class methodsFor: 'as yet unclassified' stamp: 'topa 5/27/2010 14:50'!
isAbstract

	^ self == ACParserTest! !

!ACParserTest methodsFor: 'helpers' stamp: 'topa 5/27/2010 14:48'!
match: aString with: aRule

	[ACParser matchAll: aString with: aRule]
		on: OM2Fail
		do: [^ false].
	^ true! !

ACParserTest subclass: #ACParserUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'topa 5/20/2010 09:47'!
testUserStoryInvalidNewlinesMatch

	self shouldnt: [self match: ACTestResource userStoryInvalidNewlines with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'topa 5/20/2010 09:47'!
testUserStoryInvalidOrderMatch

	self shouldnt: [self match: ACTestResource userStoryInvalidOrder with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'topa 5/20/2010 09:48'!
testUserStoryInvalidSyntaxMatch

	self shouldnt: [self match: ACTestResource userStoryInvalidSyntax with: #userStory].
	self flag: #extend. "topa: should look for position of invalid syntax"! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'topa 5/20/2010 09:48'!
testUserStoryInvalidTrailersMatch

	self shouldnt: [self match: ACTestResource userStoryInvalidTrailers with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'topa 5/20/2010 09:40'!
testUserStoryMatch

	self should: [self match: ACTestResource userStory with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/20/2010 09:46'!
testUserStoryMeansMatch

	self should: [self match: ACTestResource means with: #meansLine].	! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/20/2010 09:38'!
testUserStoryMeansOptionalToMatch

	self should: [  self match: ACTestResource meansOptionalTo with: #meansLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/20/2010 09:38'!
testUserStoryMeansOptionalToWithAnMatch

	self should: [  self match: ACTestResource meansOptionalToWithAn with: #meansLine].! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'topa 5/20/2010 09:49'!
testUserStoryMissingArgsMatch

	self shouldnt: [self match: ACTestResource userStoryMissingArgs with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'topa 5/20/2010 09:51'!
testUserStoryNewlineAfterTitleMatch
	
	self should: [self match: ACTestResource userStoryNewlineAfterTitle with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/20/2010 09:34'!
testUserStoryPurposeMatch

	self should: [  self match: ACTestResource purpose with: #purposeLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/20/2010 09:41'!
testUserStoryRoleMatch

	self should: [ self match: ACTestResource role with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/20/2010 09:41'!
testUserStoryRoleWithAnMatch

	self should: [ self match: ACTestResource roleWithAn with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/20/2010 09:41'!
testUserStoryRoleWithPluralMatch

	self shouldnt: [ self match: ACTestResource roleWithPlural with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'topa 5/20/2010 09:51'!
testUserStorySpacingMatch
	
	self should: [self match: ACTestResource userStorySpacing with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/19/2010 12:22'!
testUserStoryTitleMatch

	self should: [self match: 'A Title' with: #title].	! !

TestCase subclass: #ACTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:40'!
testGivenTranslation

	|pt sourceCode|
	
	pt:= #(given 'I have a web site').
	sourceCode:= '	self given: ''I have a web site''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:39'!
testMeansTranslation

	| pt |
	pt:= #(means 'do something.').
	self should: (ACTranslator match: pt with: #messagePart) = ('	means: ''do something.''', String cr).! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:40'!
testPurposeTranslation

	| pt |
	pt:= #(purpose 'achieve something').
	self should: (ACTranslator match: pt with: #messagePart) = ('	purpose: ''achieve something''', String cr).
	! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:41'!
testRoleTranslation

	| pt |
	pt:= #(role 'role').
	self should: (ACTranslator match: pt with: #messagePart) = ('	role: ''role''', String cr).! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:52'!
testScenarioTranslation

	|pt sourceCode|
	
	pt:= #(scenario 
		#(given 'I have a web site') 
		#(when 'I go to the web site') 
		#(then 'I see "Hello World"')).
	sourceCode:= 'scenario1
	self given: ''I have a web site''.
	self when: ''I go to the web site''.
	self then: ''I see "Hello World"''.', String cr.
	self should: (ACTranslator match: pt with: #translate) = sourceCode.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:45'!
testThenTranslation

	|pt sourceCode|
	
	pt:= #(then 'I see "Hello World"').
	sourceCode:= '	self then: ''I see "Hello World"''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:42'!
testTitleTranslation

	| pt |
	pt:= #(title 'A Title').
	self should: (ACTranslator match: pt with: #title) = ('ACUserStory named: #ATitle', String cr).! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:33'!
testUserStoryTranslation

	| pt |
	pt:= #(userStory
		#(title 'A Title') 
		#(purpose 'achieve something') 
		#(role 'role') 
		#(means 'do something.')).
	self should: (ACTranslator match: pt with: #translate) = ACTestResource userStoryDecompiled.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:40'!
testWhenTranslation

	|pt sourceCode|
	
	pt:= #(when 'I go to the web site').
	sourceCode:= '	self when: ''I go to the web site''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

TestCase subclass: #ACUserStory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Model'!

ACUserStory class
	instanceVariableNames: 'purpose role means'!

ACUserStory class
	instanceVariableNames: 'purpose role means'!

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'db 6/7/2010 14:22'!
allTestSelectors

	^#(#scenario1)
			! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:07'!
compilerClass

	^ self == ACUserStory
		ifTrue: [super compilerClass]
		ifFalse: [ACCompiler]! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:16'!
definition

	^ self == ACUserStory
		ifTrue: [super definition]
		ifFalse: [String streamContents: [:stream |
			stream
				nextPutAll: (super definition findTokens: ' ') first "superClass"; space;
				nextPutAll: 'named: '; nextPutAll: self name printString; crtab;
				nextPutAll: 'purpose: '; nextPutAll: self purpose printString; crtab;
				nextPutAll: 'role: '; nextPutAll: self role printString; crtab;
				nextPutAll: 'means: '; nextPutAll: self means printString]]! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:23'!
isAbstract

	^ self == ACUserStory! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
means

	^means! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
means: anObject

	means := anObject! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 12:48'!
named: aNameSymbol
purpose: purposeString
role: roleString
means: meansString

	|klass|		
	klass := self subclass: aNameSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self category.
	klass purpose: purposeString; role: roleString; means: meansString.
	
	^ klass! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
purpose

	^purpose! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
purpose: anObject

	purpose := anObject! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
role

	^role! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
role: anObject

	role := anObject! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'db 6/7/2010 14:57'!
given: aString
	self assert: false! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'db 6/7/2010 14:36'!
then: aString
	self assert: false! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'db 6/7/2010 14:36'!
when: aString
	self assert: false
! !

ACUserStory subclass: #AName
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Model'!

!AName methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:20'!
Given I have a web site
When I go to the web site
Then I see "Hello World"! !

!AName methodsFor: 'as yet unclassified' stamp: 'db 6/7/2010 14:07'!
Given I have a web site
When I go to the web site
Then I see "Hello World"
! !

OMeta2 subclass: #ACParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACParser methodsFor: 'helpers' stamp: 'topa 5/18/2010 18:05'!
charNoNewline =

	<char:x ?[x ~= Character cr]>! !

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 5/27/2010 14:55'!
givenLine =

	 spaces <``Given''> spaces <charNoNewline+>:body -> [{#given . body}]! !

!ACParser methodsFor: 'helpers' stamp: 'topa 5/18/2010 17:51'!
lineEnd =

	<char:x ?[x = Character cr]>! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/20/2010 09:39'!
meansLine =

	spaces <``I want'' `` to''?> spaces <charNoNewline+>:body -> [{#means . body}]! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/19/2010 13:02'!
purposeLine =

	 spaces <``In order to''> spaces <charNoNewline+>:body -> [{#purpose . body}]! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/19/2010 13:02'!
roleLine =

		 spaces <``As a'' ``n''?> spaces <charNoNewline+>:body -> [{#role . body}]! !

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 5/27/2010 14:54'!
scenario =

	givenLine:given lineEnd
	whenLine:when lineEnd
	thenLine:then lineEnd? end -> [{#scenario. given. when. then}]
	! !

!ACParser methodsFor: 'helpers' stamp: 'topa 5/20/2010 09:59'!
space =
	// we do not allow newline as whitespace
	
	^space:s ?[ ({Character cr. Character lf} noneSatisfy: [:c | c =s ])]! !

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 5/27/2010 14:55'!
thenLine =

	 spaces <``Then''> spaces <charNoNewline+>:body -> [{#then . body}]! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/19/2010 13:02'!
title =

	<charNoNewline+>:body -> [{#title . body}]! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/20/2010 10:03'!
userStory =
	
	title:t lineEnd+
	purposeLine:purpose lineEnd
	roleLine:role lineEnd
	meansLine:means lineEnd? end -> [{#userStory. t. purpose. role. means}]
	! !

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 5/27/2010 14:55'!
whenLine =

	 spaces <``When''> spaces <charNoNewline+>:body -> [{#when . body}]! !

OMeta2 subclass: #ACTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:27'!
messagePart =

	{symbol:s string:body} -> ['	', s asMutator,' ''', body,'''', String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:21'!
rule =

	{symbol:s string:body} -> ['	self ', s asMutator,' ''', body,'''.', String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:35'!
title =

	{symbol:t string:s} -> ['ACUserStory named: ', s asLegalSelector capitalized asSymbol printString, String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:27'!
translate =
	
	{symbol:type ?[type = #userStory] title:t messagePart:purpose messagePart:role messagePart:means}
		-> [t, purpose, role, means]
|	{symbol:type ?[type = #scenario] rule:given rule:when rule:then}
		-> ['scenario1', String cr, given, when, then]! !
